//"use strict";

$(document).ready(function() {
// Old method.
//	$("pre.load").prepend("<button class='load'>Load in solver</button>");

	$("pre.load").each(function () {
    	var $pre = $(this);
		var text = $pre.contents().get(0).nodeValue;

		// Trim any trailing newline.
		if (text.charAt(text.length - 1) == "\n")
			text = text.substr(0, text.length - 1);

		// First, escape the percent sign, our escape character.
		text = text.replace(/%/g, "%25");

		// Escape slashes because of JQM.
		text = text.replace(/\//g, "%2F");

		// Escape newlines because window.location.href eats them.
		text = text.replace(/\n/g, "%0A");

		// Escape ampersands, our parameter separator.
		text = text.replace(/&/g, "%26");

		// Create an anchor tag so we can right-click it. Fill the href
		// programmatically to avoid having to escape weird characters.
		var $anchor = $("<a class='button'>Load in solver</a>");
		$anchor.attr("href", "solver.html#solver?load=" + text);
		$pre.prepend($anchor);
	});

	// Build a contents section.
	var str = "<h3>Contents</h3>\n";
	str += "<ul>\n";
	var depth = 1;
	var $tags = $("h1, h2");
	for (var i = 0; i < $tags.length; i++) {
		var $tag = $tags.eq(i);
		var tagName = $tag.prop("tagName");
		var text = $tag.text();
		var id = $tag.attr("id");
		if (typeof(id) == "undefined")
			continue;	// Skip "Documentation" tag.
		if (tagName == "H2" && depth == 1) {
			str += "  <ul>\n";
			depth = 2;
		}
		else if (tagName == "H1" && depth == 2) {
			str += "  </ul></li>\n";
			depth = 1;
		}
		if (depth == 2)
			str += "  ";
		str += "<li><a href=\"#" + id + "\">" + text + "</a>";
		if (depth == 2)
			str += "</li>\n";
		else
			str += "\n";
	}
	str += "  </ul></li>\n";
	str += "</ul>\n";
	$("div.jqm-hidden").append(str);

/* old method

	$("button.load").click(function() {
    	var $pre = $(this).parent();
		var text = $pre.contents().get(1).nodeValue;

		// Trim any trailing newline.
		if (text.charAt(text.length - 1) == "\n")
			text = text.substr(0, text.length - 1);

		// First, escape the percent sign, our escape character.
		text = text.replace(/%/g, "%25");

		// Escape slashes because of JQM.
		text = text.replace(/\//g, "%2F");

		// Escape newlines because window.location.href eats them.
		text = text.replace(/\n/g, "%0A");

		// Escape ampersands, our parameter separator.
		text = text.replace(/&/g, "%26");
		window.location.href = "solver.html#solver?load=" + text;
    });
*/
});
